{%  macro color(failing, total) %}
{%   if failing == 0 %}
is-success
{%   else %}
{%     if (failing / total) <= 0.1 %}
is-warning
{%     else %}
is-danger
{%     endif %}
{%   endif %}
{% endmacro %}

{%  macro status_color(state) %}
{%   if state == "DEPLOYED" %}
<span class="tag is-success">{{ state }}</span>
{%   else %}
{%     if state == "FAILED" %}
<span class="tag is-danger">{{ state }}</span>
{%     else %}
<span class="tag is-warning">{{ state }}</span>
{%     endif %}
{%   endif %}
{% endmacro %}

{%  macro percentage(failing, total) %}
{{ ((total - failing) / total) | round }}
{% endmacro %}

{% macro statistic(resource_name, failing, total) %}
{% set success = total - failing %}
<div class="level-item has-text-centered">
    <div>
      <p class="heading">{{ resource_name | capitalize }}</p>
      <p class="title">{{ success }}/{{ total }}</p>
      <progress class="progress {{ color(failing, total) }}" value="{{ success }}" max="{{ total }}">{{ percentage(failing, total) }}</progress>
    </div>
  </div>
{% endmacro %}

{% macro summary(title, name, statistics) %}
<section class="hero is-light">
  <div class="hero-body">
    <div class="container">
      <h1 class="title is-1">
        {{ title | capitalize }} {{ name }} Summary
      </h1>
      <nav class="level">
        {% for stat in statistics %}
        {% if stat.total > 0 %}
        {{ statistic(stat.title, stat.failing, stat.total) | indent(width=8) }}
        {% endif %}
        {% endfor %}
      </nav>
    </div>
  </div>
</section>
{% endmacro %}

<!DOCTYPE html>
<html>
  <head>
    <meta charset="utf-8">
    <meta name="viewport" content="width=device-width, initial-scale=1">
    <title>Tests results - {% block title %}{% endblock %}</title>
    <link rel="stylesheet" href="https://cdn.jsdelivr.net/npm/bulma@0.8.0/css/bulma.min.css">
    <script defer src="https://use.fontawesome.com/releases/v5.3.1/js/all.js"></script>
  </head>
  <body>
    <nav class="navbar" role="navigation" aria-label="main navigation">
      <div class="navbar-brand">
        <a class="navbar-item" href="https://www.onap.org">
          <img src="https://www.onap.org/wp-content/uploads/sites/20/2017/02/logo_onap_2017.png" width="234" height="50">
        </a>

        <a role="button" class="navbar-burger burger" aria-label="menu" aria-expanded="false" data-target="navbarBasicExample">
          <span aria-hidden="true"></span>
          <span aria-hidden="true"></span>
          <span aria-hidden="true"></span>
        </a>
      </div>

      <div id="navbarBasicExample" class="navbar-menu">
        <div class="navbar-start">
          <a class="navbar-item">
            Summary
          </a>
        </div>
      </div>
    </nav>

    {% block content %}{% endblock %}

    <footer class="footer">
      <div class="container">
        <div class="columns">
          <div class="column">
        <p class="has-text-grey-light">
          <a href="https://bulma.io/made-with-bulma/">
            <img src="https://bulma.io/images/made-with-bulma.png" alt="Made with Bulma" width="128" height="24">
          </a>
        </div>
        <div class="column">
          <a class="has-text-grey" href="https://gitlab.com/Orange-OpenSource/lfn/tools/kubernetes-status" style="border-bottom: 1px solid currentColor;">
            Improve this page on Gitlab
          </a>
        </p>
      </div>
      </div>
      </div>
    </footer>
  </body>
</html>
